import { Argument, Creator } from "./types";
import { Token } from "./token";
declare class Container {
    private dependencies;
    private providers;
    private requests;
    constructor();
    add<T>(token: Token<T>, creator: Creator<T>, args?: Argument[]): void;
    share<T>(token: Token<T>, creator: Creator<T>, args?: Argument[]): void;
    constant<T>(token: Token<T>, value: T): void;
    private register;
    get<T>(token: Token<T>): T;
    getAsync<T>(token: Token<T>): Promise<T>;
    provide(tokens: Token[]): Promise<void>;
    private instantiate;
    private instantiateAsync;
    private create;
    private createAsync;
    private createSingle;
    private createSingleAsync;
    private resolve;
    private resolveAsync;
    private construct;
}
declare function createContainer(): Container;
export { Container, createContainer };
